
//=============================================================================
//
//	NeighborStoneChainEnumerator
//
//	Enumerates each neighboring chain of a chain
//	Use the StoneChainManager class to initialize this enumerator
//
//=============================================================================

#pragma once

#include "BitBoard9.h"

class StoneChain;

class NeighborStoneChainEnumerator
{
public:
	NeighborStoneChainEnumerator() 
	{ }

	void Initialize(BitBoard9 mask, StoneChain** state)
	{
		mask_  = mask;
		state_ = state;

		BitBoard9 edge;
		edge.FillEdge();

		mask_ -= edge;
	}

	StoneChain* Next();

private:
	BitBoard9 mask_;

	StoneChain** state_;
};