
//=============================================================================
//
//	StoneChainEnumerator
//
//	Enumerates each chain of the board
//	Use the StoneChainManager class to initialize.
//
//=============================================================================

#pragma once

#include "StoneChain.h"

class StoneChainEnumerator
{
public:
	StoneChainEnumerator() 
	{
		current_ = 0;
		end_ = 0;
	}

	void Initialize(StoneChain* start, StoneChain* end, bool* state)
	{
		current_ = start;
		end_ = end;
		state_ = state;
	}

	StoneChain* Next()
	{
		while(!*(state_++))
		{
			if (current_ == end_)
			{
				state_--;
				return 0;
			}
			else
				++current_;
		}

		return current_++;
	}

private:
	bool*		state_;
	StoneChain* current_;
	StoneChain* end_;
};